#include "SD.h"
#define SD_ChipSelectPin 4
#include "TMRpcm.h"
#include "SPI.h"
#include "Ultrasonic.h"

/*
Notizen:
-Alle serielle Kommunikation entfernen? 
-Package libraries? 
-Tischranderkennen kompiliert nicht 
-Licht-suchen ungenauigkeit 
-Drehschritte berechnen 
-Loop Funktion 
-Reverse schreiben 
*/

//Pins 
#define ultrasonic1Pin 7
#define ultrasonic2Pin 8 
#define feuchtigkeitPin A0
#define lautsprecherPin 9
#define rechterMotorStepPin 2
#define rechterMotorDirectionPin 3
#define linkerMotorStepPin 5
#define linkerMotorDirectionPin 6
#define linkerPhototransistorPin A1
#define rechterPhototransistorPin A2
//MOSI 11 
//MISO 12 
//CLK 13

//Variablen, Konstanten und Objekte deklarieren: 
TMRpcm tmrpcm;
Ultrasonic ultrasonic(ultrasonic1Pin);
Ultrasonic ultrasonic2(ultrasonic2Pin);
float relativeUmdrehung = 0.0; 
float relativeXPosition = 0.0; 
float relativeYPosition = 0.0; 
//boolean edge;
//boolean wall; 
int lautstaerke; 
//int feuchtigkeitMesswert = 0; 

void setup() {
  //Lautsprecher 
  tmrpcm.speakerPin = lautsprecherPin;
  Serial.begin(9600);
  
  if (!SD.begin(SD_ChipSelectPin)) {
  Serial.println("SD fail");
  return;
  }
  tmrpcm.setVolume(6);

  //Motoren 
  pinMode(rechterMotorStepPin, OUTPUT); 
  pinMode(rechterMotorDirectionPin, OUTPUT); 
  pinMode(linkerMotorStepPin, OUTPUT); 
  pinMode(linkerMotorDirectionPin, OUTPUT); 

  //Helligkeitssensor 


  //Feuchtigkeitssensor 


  //Entfernungssensor 
  //edge = false;
  //wall = false; 
}


//Funktionen!!!

boolean tischrandErkennen() {
    long DistInCent = ultrasonic.MeasureInCentimeters(); 
    Serial.println("Boden: " + (String)DistInCent + " cm");

    if(DistInCent > 5 == true) {
      return true; 
    } else {
      return false;   
    }
}

boolean wandErkennen() {
  long DistInCent = ultrasonic2.MeasureInCentimeters(); 
  Serial.println("Wand: " + (String)DistInCent + " cm");

  if(DistInCent < 5 == true) {
    return true; 
  } else {
    return false;   
  }
}

void reverse() {
    
}

void gehen(int schritt) {
  //1 Schritt = 1,4215706757 mm 
  
  //Vorwärts 
  digitalWrite(linkerMotorDirectionPin, HIGH); 
  digitalWrite(rechterMotorDirectionPin, HIGH); 

  //Schritte und Tischrand 
  for(int n = 0; n < schritt ; n++) {
    digitalWrite(rechterMotorStepPin, HIGH);  
    digitalWrite(linkerMotorStepPin, HIGH);  
    delay(1);
    digitalWrite(rechterMotorStepPin, LOW);
    digitalWrite(linkerMotorStepPin, LOW);  
    delay(1);
    if(tischrandErkennen() == true || wandErkennen() == true) {
      reverse(); 
    }
  }

  //relativeXPosition und relativeYPosition Berechen
  int rUInt = (int)relativeUmdrehung; 
  rUInt = rUInt % 360; 
  
  //Normieren/Positivieren 
  if(rUInt < 0) {
    rUInt = rUInt + 360;   
  }
  
  //Top Left 
  if(rUInt >= 0 && rUInt < 90) {
    relativeXPosition = (schritt * sin(rUInt)) * (-1); 
    relativeYPosition = (schritt * cos(rUInt)); 
  }
  //Top Right 
  else if(rUInt >= 270 && rUInt < 360) {
    relativeXPosition = schritt * sin(360 - rUInt); 
    relativeYPosition = schritt * cos(360 - rUInt);
  }
  //Bottom Left 
  else if(rUInt >= 90 && rUInt < 180) {
    relativeXPosition = (-1) * schritt * sin(180 - rUInt); 
    relativeYPosition = (schritt * cos(rUInt)) * (-1); 
  }
  //Bottom Right 
  else if(rUInt >= 180 && rUInt < 270) {
    relativeXPosition = schritt * sin(rUInt - 180); 
    relativeYPosition = (-1) * schritt * cos(rUInt - 180);
  }
}

void bellen() {
  tmrpcm.play("ronald.wav"); //Einfach ein beliebiger Name. 
  //delay(1000);
  //tmrpcm.play("FINAL.wav");
  Serial.println("Woof!");  
}

boolean feuchtigkeitMessen() {
    int messwert = analogRead(feuchtigkeitPin); 
    Serial.print("Feuchtigkeits-Messwert:" + messwert);
    if(messwert > 512) {
      return true; 
    } else {
      return false;
    }
}

boolean fakeFeuchtigkeitMessen () {
  if(random(1, 10) == 1) {
    return true;   
  }
}

void zumStartpunktGehen() {
  int rUInt = (int)relativeUmdrehung; 
  rUInt = rUInt % 360; 
  
  //Normieren/Positivieren 
  if(rUInt < 0) {
    rUInt = rUInt + 360;   
  }

  //Entfernung berechnen 
  float entfernung = sqrt(pow(relativeXPosition, 2) + pow(relativeYPosition, 2)); 

  //Top left
  if(relativeXPosition <= 0 && relativeYPosition >= 0) {
    float richtung = asin((relativeXPosition/entfernung)); 
    rotieren(-180.0 + richtung); 
    gehen(entfernung); 
  }

  //Top right 
  if(relativeXPosition >= 0 && relativeYPosition >= 0) {
    float richtung = asin((relativeXPosition/entfernung)); 
    rotieren(180.0 - richtung); 
    gehen(entfernung); 
  }

  //Bottom left
  if(relativeXPosition <= 0 && relativeYPosition >= 0) {
    float richtung = asin((relativeXPosition/entfernung)); 
    rotieren((-1) * richtung); 
    gehen(entfernung); 
  }

  //Bottom right 
  if(relativeXPosition >= 0 && relativeYPosition >= 0) {
    float richtung = asin((relativeXPosition/entfernung)); 
    rotieren(richtung); 
    gehen(entfernung); 
  }
}

void rotieren(float grad) {
  relativeUmdrehung = relativeUmdrehung + grad; 

  //Richtung bestimmen 
  if(grad < 0.0) {
    digitalWrite(linkerMotorDirectionPin, HIGH); 
    digitalWrite(rechterMotorDirectionPin, LOW);
  } else if(grad > 0.0) {
    digitalWrite(linkerMotorDirectionPin, LOW); 
    digitalWrite(rechterMotorDirectionPin, HIGH);
  }

  //Drehschritte berechnen 
  int drehschritte = (240 * PI)/1.4215; 

  //Rotieren 
  for(int i = 0; i < drehschritte; i++) {
    digitalWrite(rechterMotorStepPin, HIGH);  
    digitalWrite(linkerMotorStepPin, HIGH);  
    delay(1);
    digitalWrite(rechterMotorStepPin, LOW);
    digitalWrite(linkerMotorStepPin, LOW);  
    delay(1);
  }
}

void lichtSuchen() {
  while(linkerPhototransistorPin != rechterPhototransistorPin) {
    if(linkerPhototransistorPin > rechterPhototransistorPin){
      for(int n = 0; n<2 ; n++) {
        digitalWrite(rechterMotorStepPin, HIGH);  
        delay(1);
        digitalWrite(linkerMotorStepPin, LOW);
        delay(1);
      }
    } else 
    if(linkerPhototransistorPin < rechterPhototransistorPin){
      for(int n = 0; n < 2 ; n++) {
        digitalWrite(linkerMotorStepPin, HIGH);  
        delay(1);
        digitalWrite(rechterMotorStepPin, LOW);
        delay(1);
      }
    }
  }
} 

void loop() {
  if (feuchtigkeitMessen() == false) {
    bellen();
  }
  lichtSuchen(); 
  gehen(1);
  
  //Lautstärke messen 
  lautstaerke = analogRead(A3); 
  Serial.println("Lautstärke: " + lautstaerke); 
  delay(100); //Wieso? 
  if(lautstaerke <= 1000) {
    zumStartpunktGehen();
  }
  
}
